apps/urban_nomad_web/lib/urban_nomad_web/router.ex
defmodule UrbanNomadWeb.Router do
  use UrbanNomadWeb, :router

  pipeline :browser do
    plug(:accepts, ["html"])
    plug(:fetch_session)
    plug(:fetch_flash)
    plug(:protect_from_forgery)
    plug(:put_secure_browser_headers)
  end

  pipeline :session do
    plug(UrbanNomadWeb.Session.GuardianImpl.Pipeline)
  end

  pipeline :graphql do
    plug(
      Plug.Parsers,
      parsers: [:urlencoded, :multipart, :json, Absinthe.Plug.Parser],
      pass: ["*/*"],
      json_decoder: Jason
    )

    plug(:put_secure_browser_headers)
    plug(:accepts, ["json"])
    plug(UrbanNomadWeb.ApiGraphql.Context)
  end

  pipeline :app do
    plug(:put_layout, {UrbanNomadWeb.LayoutView, "spa.html"})
  end

  scope "/", UrbanNomadWeb do
    pipe_through([:browser, :session])

    get("/", PageController, :index)

    get("/signup", UserController, :new)
    post("/signup", UserController, :create)

    get("/signin", SessionController, :new)
    post("/signin", SessionController, :create)
    get("/signout", SessionController, :destroy)

    get("/reset-password", PasswordResetController, :new)
    post("/reset-password", PasswordResetController, :create)

    get("/reset-password/:id", PasswordResetController, :show)
    post("/reset-password/:id", PasswordResetController, :update)
  end

  scope "/app", UrbanNomadWeb do
    pipe_through([:browser, :session, :app])
    get("/*path", SPAController, :index)
  end

  scope "/api" do
    pipe_through([:session, :graphql])

    if Mix.env() == :dev do
      forward(
        "/graphiql",
        Absinthe.Plug.GraphiQL,
        schema: UrbanNomadWeb.ApiGraphql.Schema
      )
    end

    forward(
      "/",
      Absinthe.Plug,
      schema: UrbanNomadWeb.ApiGraphql.Schema
    )
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/controllers/page_controller.ex
defmodule UrbanNomadWeb.PageController do
  use UrbanNomadWeb, :controller

  def index(conn, _params) do
    render(conn, "index.html")
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/controllers/password_reset_controller.ex
defmodule UrbanNomadWeb.PasswordResetController do
  @moduledoc false

  use UrbanNomadWeb, :controller

  alias UrbanNomad.{
    PasswordReset,
    User
  }

  alias UrbanNomadWeb.{
    ErrorView,
    PasswordResetController.PasswordResetRequest,
    PasswordResetController.PasswordUpdateRequest,
    Session
  }

  plug(:redirect_if_authenticated when action in [:new, :create])
  plug(:validate_password_reset_code when action in [:show, :update])

  def new(conn, _params) do
    changeset = PasswordResetRequest.changeset()
    render(conn, "new.html", changeset: changeset)
  end

  def create(conn, %{"password_reset" => password_reset_params}) do
    with {:ok, %PasswordReset{}} <- PasswordResetRequest.run(password_reset_params) do
      conn
      |> put_flash(:info, "Password Reset Instruction send.")
      |> redirect(to: Routes.password_reset_path(conn, :new))
    else
      {:error, changeset} ->
        render(conn, "new.html", changeset: changeset)
    end
  end

  def show(conn, _params) do
    changeset = PasswordUpdateRequest.changeset()
    render(conn, "show.html", changeset: changeset)
  end

  def update(conn, %{"update_password" => update_password_params}) do
    # XXX-jt-151118 enhance params with password_reset_code
    password_reset_code = conn.assigns.password_reset.code
    params = update_password_params |> Map.put("password_reset_code", password_reset_code)

    case PasswordUpdateRequest.run(params) do
      {:ok, %User{}} ->
        conn
        |> put_flash(:info, "Password updated.")
        |> redirect(to: Routes.session_path(conn, :new))

      {:error, changeset} ->
        render(conn, "show.html", changeset: changeset)
    end
  end

  defp redirect_if_authenticated(conn, _opts) do
    if Session.authenticated?(conn) do
      conn
      |> redirect(to: Routes.page_path(conn, :index))
    else
      conn
    end
  end

  defp validate_password_reset_code(conn, _opts) do
    code = conn.params["id"]

    case UrbanNomad.validate_password_reset_code(code) do
      {:ok, password_reset} ->
        conn |> assign(:password_reset, password_reset)

      _ ->
        conn
        |> put_status(404)
        |> put_view(ErrorView)
        |> render("404.html")
        |> halt()
    end
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/controllers/session_controller.ex
defmodule UrbanNomadWeb.SessionController do
  @moduledoc false
  use UrbanNomadWeb, :controller

  alias UrbanNomad.User

  alias UrbanNomadWeb.{
    Session,
    SessionController.SigninUserRequest
  }

  plug(:redirect_if_authenticated when action in [:new, :create])

  def new(conn, _params) do
    changeset = SigninUserRequest.changeset()
    render(conn, "new.html", changeset: changeset)
  end

  def create(conn, %{"session" => session_params}) do
    with {:ok, %User{} = user} <- SigninUserRequest.run(session_params),
         conn <- conn |> Session.sign_in(user) do
      conn
      |> put_flash(:info, "User loggin successfully.")
      |> redirect(to: Routes.page_path(conn, :index))
    else
      {:error, changeset} ->
        render(conn, "new.html", changeset: changeset)
    end
  end

  def destroy(conn, _) do
    conn
    |> Session.sign_out()
    |> put_flash(:info, "User loggout successfully.")
    |> redirect(to: Routes.session_path(conn, :new))
  end

  defp redirect_if_authenticated(conn, _opts) do
    if Session.authenticated?(conn) do
      conn
      |> redirect(to: Routes.page_path(conn, :index))
    else
      conn
    end
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/controllers/spa_controller.ex
defmodule UrbanNomadWeb.SPAController do
  @moduledoc false
  use UrbanNomadWeb, :controller
  alias UrbanNomadWeb.Session

  plug(:redirect_if_authenticated)

  def index(conn, _params) do
    token = conn |> Session.current_token()

    conn
    |> assign(:token, token)
    |> render("index.html")
  end

  defp redirect_if_authenticated(conn, _opts) do
    if Session.authenticated?(conn) do
      conn
    else
      conn
      |> redirect(to: Routes.page_path(conn, :index))
    end
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/controllers/user_controller.ex
defmodule UrbanNomadWeb.UserController do
  @moduledoc false
  use UrbanNomadWeb, :controller

  alias UrbanNomad.User

  alias UrbanNomadWeb.{
    Session,
    UserController.RegisterUserRequest
  }

  alias UrbanNomadWeb.Session

  plug(:redirect_if_authenticated when action in [:new, :create])

  def new(conn, _params) do
    changeset = RegisterUserRequest.changeset()
    render(conn, "new.html", changeset: changeset)
  end

  def create(conn, %{"user" => user_params}) do
    with {:ok, %User{} = user} <- RegisterUserRequest.run(user_params),
         conn <- conn |> Session.sign_in(user) do
      conn
      |> put_flash(:info, "User created successfully.")
      |> redirect(to: Routes.page_path(conn, :index))
    else
      {:error, changeset} ->
        render(conn, "new.html", changeset: changeset)
    end
  end

  defp redirect_if_authenticated(conn, _opts) do
    if Session.authenticated?(conn) do
      conn
      |> redirect(to: Routes.page_path(conn, :index))
    else
      conn
    end
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/views/error_view.ex
defmodule UrbanNomadWeb.ErrorView do
  use UrbanNomadWeb, :view

  alias Phoenix.Controller
  # If you want to customize a particular status code
  # for a certain format, you may uncomment below.
  # def render("500.html", _assigns) do
  #   "Internal Server Error"
  # end

  # By default, Phoenix returns the status message from
  # the template name. For example, "404.html" becomes
  # "Not Found".
  def template_not_found(template, _assigns) do
    Controller.status_message_from_template(template)
  end
end

apps/urban_nomad_web/lib/urban_nomad_web/views/layout_view.ex
defmodule UrbanNomadWeb.LayoutView do
  use UrbanNomadWeb, :view

  alias UrbanNomadWeb.Session
end

apps/urban_nomad_web/lib/urban_nomad_web/views/page_view.ex
defmodule UrbanNomadWeb.PageView do
  use UrbanNomadWeb, :view
end

apps/urban_nomad_web/lib/urban_nomad_web/views/password_reset_view.ex
defmodule UrbanNomadWeb.PasswordResetView do
  use UrbanNomadWeb, :view
end

apps/urban_nomad_web/lib/urban_nomad_web/views/session_view.ex
defmodule UrbanNomadWeb.SessionView do
  use UrbanNomadWeb, :view
end

apps/urban_nomad_web/lib/urban_nomad_web/views/spa_view.ex
defmodule UrbanNomadWeb.SPAView do
  use UrbanNomadWeb, :view
end

apps/urban_nomad_web/lib/urban_nomad_web/views/user_view.ex
defmodule UrbanNomadWeb.UserView do
  use UrbanNomadWeb, :view
end

apps/urban_nomad_web/lib/urban_nomad_web/templates/layout/app.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <%= if assigns[:page_title] do %>
      <title><%= @page_title %></title>
    <% else %>
      <title>Urban Nomad</title>
    <% end %>
    <link rel="stylesheet" href="<%= Routes.static_path(@conn, "/css/app.css") %>"/>
  </head>
  <body>
    <div class="l-page">
      <header class="l-header">
        <nav class="m-nav" role="navigation">
          <%= link(gettext("Home"), to: Routes.page_path(@conn, :index)) %>
          <ul class="m-nav__list">
            <li><%= link(gettext("Pricing"), to: Routes.page_path(@conn, :index), class: "m-btn") %></li>
            <li><%= link(gettext("Help"), to: Routes.page_path(@conn, :index), class: "m-btn") %></li>
            <%= if Session.authenticated?(@conn) do %>
              <li><%= link(gettext("Log Out"), to: Routes.session_path(@conn, :destroy), class: "m-btn") %></li>
          <% else %>
            <li><%= link(gettext("Log In"), to: Routes.session_path(@conn, :new), class: "m-btn") %></li>
            <li><%= link(gettext("Get Started"), to: Routes.user_path(@conn, :new), class: "m-btn m-btn--primary m-btn--ghost") %></li>
          <% end %>
          </ul>
        </nav>
      </header>
      <div class="m-flash m-flash--info"><%= get_flash(@conn, :info) %></div>
      <div class="m-flash m-flash--error"><%= get_flash(@conn, :error) %></div>
      <main class="l-main" role="main">
        <%= render @view_module, @view_template, assigns %>
      </main>
      <footer class="l-footer">
        Footer
      </footer>
    </div>
    <script type="text/javascript" src="<%= Routes.static_path(@conn, "/js/page.js") %>"></script>
  </body>
</html>

apps/urban_nomad_web/lib/urban_nomad_web/templates/layout/spa.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <base href="/app">
    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <meta name="token" content="<%= assigns[:token] %>" />
    <%= if assigns[:page_title] do %>
      <title><%= @page_title %></title>
    <% else %>
      <title>Urban Nomad</title>
    <% end %>
    <link rel="stylesheet" href="<%= Routes.static_path(@conn, "/css/app.css") %>"/>
  </head>
  <body>
    <%= render @view_module, @view_template, assigns %>

    <script type="text/javascript" src="<%= Routes.static_path(@conn, "/js/app.js") %>"></script>
  </body>
</html>

apps/urban_nomad_web/lib/urban_nomad_web/templates/page/index.html.eex
<section class="phx-hero">
  <h1><%= gettext "Welcome to %{name}!", name: "UrbanNomad" %></h1>
  <p><%= gettext "Urban nomads are a new society definition for urban society that has put bigger portion of mobility in their daily lives." %></p>
</section>

apps/urban_nomad_web/lib/urban_nomad_web/templates/password_reset/new.html.eex
<article class="m-card m-card--accounts">
  <header>
    <h1><%= gettext "Reset your password!" %></h1>
    <p><%= gettext "Enter your email address and we will send you a link to reset your password." %></p>
  </header>
  <div class="m-card__content">
    <%= render "new_form.html", Map.put(assigns, :action, Routes.password_reset_path(@conn, :create)) %>
  </div>
</article>

apps/urban_nomad_web/lib/urban_nomad_web/templates/password_reset/new_form.html.eex
<%= form_for @changeset, @action, [as: :password_reset, class: "m-form"], fn f -> %>
  <%= if @changeset.action do %>
    <div class="m-form__group">
      <span class="m-form__info m-form__info--error">
      <%= gettext "Sorry your provided email address is not in our system." %>
      </span>
    </div>
  <% end %>

  <div class="m-form__group">
    <%= label f, :email, class: "m-form__label" %>
    <%= text_input f, :email, class: "m-form__input" %>
  </div>

  <div class="m-form__group m-form__group--cta">
    <%= submit gettext("Send password reset email"), class: "m-btn m-btn--primary" %>
  </div>
<% end %>

apps/urban_nomad_web/lib/urban_nomad_web/templates/password_reset/show.html.eex
<article class="m-card m-card--accounts">
  <header>
    <h1><%= gettext "Reset your password!" %></h1>
    <p><%= gettext "Enter your new password." %></p>
  </header>
  <div class="m-card__content">
    <%= render "show_form.html", Map.put(assigns, :action, Routes.password_reset_path(@conn, :update, assigns.password_reset.code)) %>
  </div>
</article>

apps/urban_nomad_web/lib/urban_nomad_web/templates/password_reset/show_form.html.eex
<%= form_for @changeset, @action, [as: :update_password, class: "m-form"], fn f -> %>
  <%= if @changeset.action do %>
    <div class="m-form__group">
      <span class="m-form__info m-form__info--error">
      <%= gettext "Sorry your entered passwords are invalid." %>
      <%= gettext "Make sure they have at least 8 characters." %>
      </span>
    </div>
  <% end %>

  <div class="m-form__group">
    <%= label f, :password, class: "m-form__label" %>
    <%= password_input f, :password, class: "m-form__input" %>
    <%= error_tag f, :password %>
  </div>

  <div class="m-form__group">
    <%= label f, :password_confirmation, class: "m-form__label" %>
    <%= password_input f, :password_confirmation, class: "m-form__input" %>
    <%= error_tag f, :password_confirmation %>
  </div>

  <div class="m-form__group m-form__group--cta">
    <%= submit gettext("Update your Password"), class: "m-btn m-btn--primary" %>
  </div>
<% end %>

apps/urban_nomad_web/lib/urban_nomad_web/templates/session/form.html.eex
<%= form_for @changeset, @action, [as: :session, class: "m-form"], fn f -> %>
  <%= if @changeset.action do %>
    <div class="m-form__group">
      <span class="m-form__info m-form__info--error">
      <%= gettext "Incorrect email address or password." %>
      </span>
    </div>
  <% end %>

  <div class="m-form__group">
    <%= label f, :email, class: "m-form__label" %>
    <%= text_input f, :email, class: "m-form__input" %>
  </div>

  <div class="m-form__group">
    <%= label f, :password, class: "m-form__label" do %>
      <%= gettext "Password" %>
      <%= link(gettext("Forgot password?"), to: Routes.password_reset_path(@conn, :new)) %>
    <% end %>
    <%= password_input f, :password, class: "m-form__input" %>
  </div>

  <div class="m-form__group m-form__group--cta">
    <%= link(gettext("Don't have an account? Sign up!"), to: Routes.user_path(@conn, :new), class: "m-btn m-btn--text m-btn--sm") %>
    <%= submit gettext("Sign in"), class: "m-btn m-btn--primary" %>
  </div>
<% end %>

apps/urban_nomad_web/lib/urban_nomad_web/templates/session/new.html.eex
<article class="m-card m-card--accounts">
  <header>
    <h1><%= gettext "Welcome Back!" %></h1>
    <p><%= gettext "We're so excited to see you again!" %></p>
  </header>
  <div class="m-card__content">
    <%= render "form.html", Map.put(assigns, :action, Routes.session_path(@conn, :create)) %>
  </div>
</article>

apps/urban_nomad_web/lib/urban_nomad_web/templates/spa/index.html.eex
<div id="root"></div>

apps/urban_nomad_web/lib/urban_nomad_web/templates/user/form.html.eex
<%= form_for @changeset, @action, [as: :user, class: "m-form"], fn f -> %>
  <%= if @changeset.action do %>
    <div class="m-form__group">
      <span class="m-form__info m-form__info--error">
        <%= gettext "Oops, something went wrong. Please check your entered data." %>
      </span>
    </div>
  <% end %>

  <div class="m-form__group">
    <%= label f, :display_name, class: "m-form__label" %>
    <%= text_input f, :display_name, [class: "m-form__input", required: true] %>
    <%= error_tag f, :display_name %>
    <span class="m-form__info"><%=
gettext "This will be your username. You can add the name of your organization later." %>
  </div>

  <div class="m-form__group">
    <%= label f, :email, class: "m-form__label" %>
    <%= email_input f, :email, [class: "m-form__input", required: true] %>
    <%= error_tag f, :email %>
    <span class="m-form__info"><%=
gettext "We’ll occasionally send updates about your account to this inbox. We’ll never share your email address with anyone." %></span>
  </div>

  <div class="m-form__group">
    <%= label f, :password, class: "m-form__label" %>
    <%= password_input f, :password, [class: "m-form__input", required: true] %>
    <%= error_tag f, :password %>
    <span class="m-form__info"><%= gettext "Make sure it has at least 8 characters." %></span>
  </div>

  <div class="m-form__group m-form__group--cta">
    <%= link(gettext("Already have an account? Sign in!"), to: Routes.session_path(@conn, :new), class: "m-btn m-btn--text m-btn--sm") %>
    <%= submit gettext("Sign up"), class: "m-btn m-btn--primary" %>
  </div>
<% end %>

apps/urban_nomad_web/lib/urban_nomad_web/templates/user/new.html.eex
<article class="m-card m-card--accounts">
  <header>
    <h1><%= gettext "Join %{name}!", name: "Urban Nomad" %></h1>
    <p><%= gettext "The best way to design, build, and ship ideas." %></p>
  </header>
  <div class="m-card__content">
    <%= render "form.html", Map.put(assigns, :action, Routes.user_path(@conn, :create)) %>
  </div>
</article>